package asteroid.strategy.measure;

import asteroid.PrintWriterFormat;
import asteroid.model.AEnemy;
import asteroid.model.Asteroid;
import asteroid.model.FlyDetect;
import asteroid.model.ICompute;
import asteroid.model.Ship;
import asteroid.model.Shot;
import asteroid.model.Ufo;

public abstract class AMeasure implements ICompute {
	public static double MAX_IGNORE = 9999999.0;

	protected AMeasure() {
	}

	public final void forAsteroid( FlyDetect detect) {
	}

	public final void forAsteroid( Asteroid ast) {
		measure( ast);
	}

	public final void forShip( Ship ship) {
	}

	public final void forShot( FlyDetect detect) {
	}

	public final void forShot( Shot shot) {
	}

	public final void forUfo( Ufo ufo) {
		measure( ufo);
	}

	protected abstract void measure( AEnemy enemy);

	protected abstract void print( AEnemy enemy, PrintWriterFormat out);
}
